/*	DataIOSoundRecorder.h
 * copyright 2003, OpenBeOS project
 * Francois Revol, revol@free.fr
 * released under MIT license
 */

#if !defined(_DATAIO_SOUND_RECORDER_H)
#define _DATAIO_SOUND_RECORDER_H


#include <DataIO.h>
#include <SoundRecorder.h>

// use with:
// using namespace BPrivate::Media::Experimental;

namespace BPrivate {
namespace Media {
namespace Experimental {

class BAudioRingBuffer;

class BDataIOSoundRecorder : public BSoundRecorder, public BDataIO {
public:
		virtual	~BDataIOSoundRecorder();
		BDataIOSoundRecorder(
				media_multi_audio_format *format, 
				bool waitForInputConnection = false,
				const char *name = NULL);
		virtual ssize_t	Read(void *buffer, size_t size);
		virtual ssize_t	Write(const void *buffer, size_t size);
		
private:
/*
virtual void Notify(
				sound_recorder_notification what,
				...);
*/
virtual void RecordBuffer(
				bigtime_t time,
				void * buffer,
				size_t size,
				const media_multi_audio_format & format);

	BAudioRingBuffer *fRingBuffer;
};

} // Experimental
} // Media
} // BPrivate

#endif /* _DATAIO_SOUND_RECORDER_H */
