#include <Debug.h>
#include <NodeInfo.h>
#include <MediaFile.h>
#include <MediaTrack.h>
#include <MediaNode.h>
#include <MediaRoster.h>
#include <TimeSource.h>
#include <String.h>
#include <Entry.h>
#include <stdio.h>

#include <DataIOSoundRecorder.h>

#include "AudioRingBuffer.h"
	
using namespace BPrivate::Media::Experimental;

/* fool BeIDE function parser */
#define IN_NAMESPACE \
namespace BPrivate { \
namespace Media { \
namespace Experimental {
IN_NAMESPACE
#undef IN_NAMESPACE

#define BSNDREC "BSoundRecorder:"

BDataIOSoundRecorder::BDataIOSoundRecorder(
				media_multi_audio_format *format, 
				bool waitForInputConnection,
				const char *name) :
				BSoundRecorder(format, waitForInputConnection, name),
				BDataIO(),
				fRingBuffer(NULL)
{
	if (InitCheck())
		return;
	SetInitError(B_NO_INIT);
	fRingBuffer = new BAudioRingBuffer(format->buffer_size);
	SetInitError(fRingBuffer->InitCheck());
}


BDataIOSoundRecorder::~BDataIOSoundRecorder()
{
	delete fRingBuffer;
}

ssize_t	BDataIOSoundRecorder::Read(void *buffer, size_t size)
{
	if (InitCheck())
		return B_NO_INIT;
	return fRingBuffer->Read(buffer, size);
}

ssize_t	BDataIOSoundRecorder::Write(const void *buffer, size_t size)
{
	return EINVAL;
}
	
void
BDataIOSoundRecorder::RecordBuffer(
	bigtime_t timestamp, 
	void * data,
	size_t size, 
	const media_multi_audio_format & format)
{
	PRINT((BSNDREC": RecordFile callback\n"));
	//	Callback called from the SoundConsumer when receiving buffers.

	fRingBuffer->Write(data, size);
/*	if (_RecordFunc)
		(*_RecordFunc)(_m_cookie, timestamp, data, size, format);
*/
	BSoundRecorder::RecordBuffer(timestamp, data, size, format);
}
/*
void
BDataIOSoundRecorder::Notify(
//	void * cookie,
	sound_recorder_notification code,
	...)
{
	int32 cookie;
//	BSoundRecorder *inst = (BSoundRecorder *) cookie;
	PRINT((BSNDREC"Notify(%ld, ...)\n", (int32)code));
	switch (code) {
	case B_CONNECTED:
		_m_lock.Lock();
		cookie = 0;
		_m_node->GetNextInput(&cookie, &m_input);
		m_isConnected = true;
		if (_m_gotConnection > B_OK) {
			release_sem(_m_gotConnection);
		}
		_m_lock.Unlock();
		break;
	case B_DISCONNECTED:
		_m_lock.Lock();
		m_isConnected = false;
		_m_lock.Unlock();
		break;
	case B_FORMAT_CHANGED:
		_m_lock.Lock();
		cookie = 0;
		_m_node->GetNextInput(&cookie, &m_input);
		_m_lock.Unlock();
		break;
	case B_NODE_DIES:
//		Stop();
		_m_lock.Lock();
		m_isConnected = false;
		
		_m_lock.Unlock();
	default:
		return;
	}
	if (_NotifyFunc)
		(*_NotifyFunc)(_m_cookie, code);
}
*/

} // Experimental
} // Media
} // BPrivate

