/**
 * \file MediaUtils.h
 * \brief Media related functions.
 * \author Marcus Overhagen, Francois Revol
 * Copyright 2003, OpenBeOS.
 */

#ifndef __MediaUtil_h
#define __MediaUtil_h

#include <stdio.h>
#include <MediaDefs.h>

// use with:
// using namespace BPrivate::Media::utils;

namespace BPrivate {
namespace Media {
namespace utils {

/* toFile can be stdout or stderr...) */
void fprint_media_format(FILE *toFile, media_format *format, const char *prefix=NULL);

double us_to_s(bigtime_t usecs);
bigtime_t s_to_us(double secs);
int bytes_per_frame(const media_raw_audio_format & format);
int frames_per_buffer(const media_raw_audio_format & format);
bigtime_t buffer_duration(const media_raw_audio_format & format);
bigtime_t frames_duration(const media_raw_audio_format & format, int64 num_frames);
int buffers_for_duration(const media_raw_audio_format & format, bigtime_t duration);
int64 frames_for_duration(const media_raw_audio_format & format, bigtime_t duration);

}; // namespace utils
}; // namespace Media
}; // namespace BPrivate

#endif /* __MediaUtil_h */
